--[[
Chat Alert
        Author:         Zuul
	WoW-Server:	Alleria (german)
	WoW-Characters: Loanadai, Soleandra
        This Version:	-----------------------------------------------------------------------------------
			 1.1	02.09.2006	add slider for changing text height 
						greater text will now be displayed in an outline format
			 1.2	09.09.2006	alerts will be drawn in the specific chat channel color
			 1.3	19.09.2006	configure each named channel itself
			-----------------------------------------------------------------------------------
        Change Log:	see readme.txt
]]

----------------------
-- global variables --
----------------------

ChatAlert_on = 1;
ChatAlert_testmode = 0;

ChatAlert_TextSettings = {};
ChatAlert_SoundSettings = {};

ChatAlert_TextSettings["TextXPos"] = 0;
ChatAlert_TextSettings["TextYPos"] = -80;
ChatAlert_TextSettings["fadeTime"] = 2;

ChatAlert_TextSettings["party"] = 1;
ChatAlert_TextSettings["raid"] = 1;
ChatAlert_TextSettings["guild"] = 1;
ChatAlert_TextSettings["whisper"] = 1;
ChatAlert_TextSettings["channel"] = 1;
ChatAlert_TextSettings["say"] = 1;
ChatAlert_TextSettings["yell"] = 1;

ChatAlert_TextSettings["textHeight"] = 22;

ChatAlert_SoundSettings["party"] = 1;
ChatAlert_SoundSettings["raid"] = 1;
ChatAlert_SoundSettings["guild"] = 1;
ChatAlert_SoundSettings["whisper"] = 1;
ChatAlert_SoundSettings["channel"] = 1;
ChatAlert_SoundSettings["say"] = 1;
ChatAlert_SoundSettings["yell"] = 1;

ChatAlert_color = {};
ChatAlert_color["r"] = 1.0;
ChatAlert_color["g"] = 0.0;
ChatAlert_color["b"] = 0.5;

ChatAlert_List = {};

---------------------
-- local variables --
---------------------

local ChatAlert_my_variables = {};
local SortedTable;					-- Table to sort the indices of the named channel list
local sizeSortedTable;					-- Current size of SortedTable

ChatAlert_ITEM_HEIGHT  = 20;			-- Height of a line in the scrolling list
ChatAlert_ITEMS_SHOWN  = 14;			-- Number of lines in the scrolling list


---------------
-- functions --
---------------

function ChatAlert_OnUpdate()
end

function ChatAlert_OnLoad()
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("CHAT_MSG_SYSTEM");
	this:RegisterEvent("CHAT_MSG_GUILD");
	this:RegisterEvent("CHAT_MSG_OFFICER");
	this:RegisterEvent("CHAT_MSG_PARTY");
	this:RegisterEvent("CHAT_MSG_WHISPER");
	this:RegisterEvent("CHAT_MSG_RAID");
	this:RegisterEvent("CHAT_MSG_RAID_LEADER");
	this:RegisterEvent("CHAT_MSG_RAID_WARNING");
--	this:RegisterEvent("CHAT_MSG_BATTLEGROUND");
--	this:RegisterEvent("CHAT_MSG_BATTLEGROUND_LEADER");


	this:RegisterEvent("CHAT_MSG_SAY");
	this:RegisterEvent("CHAT_MSG_YELL");
	this:RegisterEvent("CHAT_MSG_CHANNEL");

--	this:RegisterEvent("CHAT_MSG_MONSTER_EMOTE");
	this:RegisterEvent("CHAT_MSG_MONSTER_SAY");
	this:RegisterEvent("CHAT_MSG_MONSTER_WHISPER");
	this:RegisterEvent("CHAT_MSG_MONSTER_YELL");

	this:RegisterEvent("CHAT_MSG_CHANNEL_NOTICE");

	SlashCmdList["ChatAlertCOMMAND"] = ChatAlert_SlashCmd;
	SLASH_ChatAlertCOMMAND1 = "/ChatAlert";
	SLASH_ChatAlertCOMMAND2 = "/CA";
	ChatAlert_print(ChatAlert_TITLE);
end

function ChatAlert_Initialize()
	AlertFrame:SetBackdropBorderColor(1, 1, 1, 0);	-- hide the alert frame border
	AlertFrame:SetPoint("CENTER", "UIParent", "CENTER", ChatAlert_TextSettings["TextXPos"], ChatAlert_TextSettings["TextYPos"]);

	ChatAlert_config_TYell:SetChecked(ChatAlert_TextSettings["yell"]);
	ChatAlert_config_TSay:SetChecked(ChatAlert_TextSettings["say"]);
	ChatAlert_config_TWhisper:SetChecked(ChatAlert_TextSettings["whisper"]);
	ChatAlert_config_TGuild:SetChecked(ChatAlert_TextSettings["guild"]);
	ChatAlert_config_TParty:SetChecked(ChatAlert_TextSettings["party"]);
	ChatAlert_config_TRaid:SetChecked(ChatAlert_TextSettings["raid"]);
	ChatAlert_config_TChannel:SetChecked(ChatAlert_TextSettings["channel"]);

	ChatAlert_config_SYell:SetChecked(ChatAlert_SoundSettings["yell"]);
	ChatAlert_config_SSay:SetChecked(ChatAlert_SoundSettings["say"]);
	ChatAlert_config_SWhisper:SetChecked(ChatAlert_SoundSettings["whisper"]);
	ChatAlert_config_SGuild:SetChecked(ChatAlert_SoundSettings["guild"]);
	ChatAlert_config_SParty:SetChecked(ChatAlert_SoundSettings["party"]);
	ChatAlert_config_SRaid:SetChecked(ChatAlert_SoundSettings["raid"]);
	ChatAlert_config_SChannel:SetChecked(ChatAlert_SoundSettings["channel"]);

	ChatAlert_config_MTYell:SetChecked(ChatAlert_TextSettings["monster_yell"]);
	ChatAlert_config_MTSay:SetChecked(ChatAlert_TextSettings["monster_say"]);
	ChatAlert_config_MTWhisper:SetChecked(ChatAlert_TextSettings["monster_whisper"]);

	ChatAlert_config_MSYell:SetChecked(ChatAlert_SoundSettings["monster_yell"]);
	ChatAlert_config_MSSay:SetChecked(ChatAlert_SoundSettings["monster_say"]);
	ChatAlert_config_MSWhisper:SetChecked(ChatAlert_SoundSettings["monster_whisper"]);

	ChatAlert_config_XSlider.tooltipText = ChatAlert_TEXT_XSLIDERTOOLTIP;
	ChatAlert_config_XSlider:SetValue(ChatAlert_TextSettings["TextXPos"]);
	ChatAlert_config_XSliderText:SetText(ChatAlert_TEXT_XSLIDERNAME..": "..ChatAlert_TextSettings["TextXPos"]);
	ChatAlert_config_XSliderLow:SetText();
	ChatAlert_config_XSliderHigh:SetText();

	ChatAlert_config_YSlider.tooltipText = ChatAlert_TEXT_YSLIDERTOOLTIP;
	ChatAlert_config_YSlider:SetValue(ChatAlert_TextSettings["TextYPos"]);
	ChatAlert_config_YSliderText:SetText(ChatAlert_TEXT_YSLIDERNAME..": "..ChatAlert_TextSettings["TextYPos"]);
	ChatAlert_config_YSliderLow:SetText();
	ChatAlert_config_YSliderHigh:SetText();

	ChatAlert_config_TimeSlider.tooltipText = ChatAlert_TEXT_TIMESLIDERTOOLTIP;
	ChatAlert_config_TimeSlider:SetValue(ChatAlert_TextSettings["fadeTime"]);
	ChatAlert_config_TimeSliderText:SetText(ChatAlert_TEXT_TIMESLIDERNAME..": "..ChatAlert_TextSettings["fadeTime"].." s");
	ChatAlert_config_TimeSliderLow:SetText();
	ChatAlert_config_TimeSliderHigh:SetText();

	if (not ChatAlert_TextSettings["textHeight"]) then
		ChatAlert_TextSettings["textHeight"] = 22;
	end
	ChatAlert_config_HeightSlider.tooltipText = ChatAlert_TEXT_HEIGHTSLIDERTOOLTIP;
	ChatAlert_config_HeightSlider:SetValue(ChatAlert_TextSettings["textHeight"]);
	ChatAlert_config_HeightSliderText:SetText(ChatAlert_TEXT_HEIGHTSLIDERNAME..": "..ChatAlert_TextSettings["textHeight"].." px");
	ChatAlert_config_HeightSliderLow:SetText();
	ChatAlert_config_HeightSliderHigh:SetText();
	ChatAlert_SetFontHeight(ChatAlert_TextSettings["textHeight"]);

	ChatAlert_config_AlertColorSwatch_NormalTexture:SetVertexColor(ChatAlert_color["r"], ChatAlert_color["g"], ChatAlert_color["b"]);

	-- Make the options frame closable with ESC:
	table.insert(UISpecialFrames,"ChatAlert_config");

	ChatAlert_config:Hide();
	ChatAlert_info();
	AlertFrame:SetTimeVisible(10);
	ChatAlert_OwnMessage(ChatAlert_TEXT_HOWTO);
	AlertFrame:SetTimeVisible(ChatAlert_TextSettings["fadeTime"]);
	PlaySoundFile("Interface\\AddOns\\ChatAlert\\Soundfiles\\ca_loaded.wav");
end

function ChatAlert_OnEvent()
	if (ChatAlert_testmode == 1) then
		ChatAlert_print("event = "..event);
		PlaySoundFile("Sound\\interface\\MagicClick.wav");
	end

	if (event == "VARIABLES_LOADED") then
		ChatAlert_Initialize();
		return;
	end

	if (ChatAlert_on == 0) then
		return;
	end

	local pName = UnitName("player");
	local sName = arg2;

	if (pName == sName and ChatAlert_testmode == 0) then
		return;
	end

	local sMsg  = arg1;
	if (not sName) then
		sName = "nil";
	end

	if (type(sMsg) == "string") then
		if     (strsub(event, 1, 23) == "CHAT_MSG_CHANNEL_NOTICE") then
			if (arg1 == "YOU_JOINED") or (arg1 == "YOU_CHANGED") then
				ChatAlert_AddNamedChannel(arg9);
			end
		elseif  (strsub(event, 1, 13) == "CHAT_MSG_RAID") then
			if (ChatAlert_SoundSettings["raid"] == 1) then
				PlaySoundFile("Interface\\AddOns\\ChatAlert\\Soundfiles\\ca_raid.wav");
			end
			if (ChatAlert_TextSettings["raid"] == 1) then
				ChatAlert_ChatMessage("[" .. "Raid/" .. sName .. ChatAlert_TEXT_SAY .. sMsg, ChatTypeInfo["RAID"]);
			end
		elseif (event == "CHAT_MSG_WHISPER") then
			if (ChatAlert_SoundSettings["whisper"] == 1) then
				PlaySoundFile("Interface\\AddOns\\ChatAlert\\Soundfiles\\ca_whisper.wav");
			end
			if (ChatAlert_TextSettings["whisper"] == 1) then
				ChatAlert_ChatMessage("[" .. sName .. ChatAlert_TEXT_WHISPER .. sMsg, ChatTypeInfo["WHISPER"]);
			end
		elseif (strsub(event, 1, 14) == "CHAT_MSG_PARTY") then
			if (ChatAlert_SoundSettings["party"] == 1) then
				PlaySoundFile("Interface\\AddOns\\ChatAlert\\Soundfiles\\ca_party.wav");
			end
			if (ChatAlert_TextSettings["party"] == 1) then
				ChatAlert_ChatMessage("[" .. "Gruppe/" .. sName .. ChatAlert_TEXT_SAY .. sMsg, ChatTypeInfo["PARTY"]);
			end
		elseif (strsub(event, 1, 14) == "CHAT_MSG_GUILD") then
			if (ChatAlert_SoundSettings["guild"] == 1) then
				PlaySoundFile("Interface\\AddOns\\ChatAlert\\Soundfiles\\ca_guild.wav");
			end
			if (ChatAlert_TextSettings["guild"] == 1) then
				ChatAlert_ChatMessage("[" .. "Gilde/" .. sName .. ChatAlert_TEXT_SAY .. sMsg, ChatTypeInfo["GUILD"]);
			end
		elseif (strsub(event, 1, 16) == "CHAT_MSG_OFFICER") then
			if (ChatAlert_SoundSettings["guild"] == 1) then
				PlaySoundFile("Interface\\AddOns\\ChatAlert\\Soundfiles\\ca_guild.wav");
			end
			if (ChatAlert_TextSettings["guild"] == 1) then
				ChatAlert_ChatMessage("[" .. "Gilde/" .. sName .. ChatAlert_TEXT_SAY .. sMsg, ChatTypeInfo["OFFICER"]);
			end
		elseif (strsub(event, 1, 12) == "CHAT_MSG_SAY") then
			if (ChatAlert_SoundSettings["say"] == 1) then
				PlaySoundFile("Interface\\AddOns\\ChatAlert\\Soundfiles\\ca_say.wav");
			end
			if (ChatAlert_TextSettings["say"] == 1) then
				ChatAlert_ChatMessage("[" .. sName .. ChatAlert_TEXT_SAY .. sMsg, ChatTypeInfo["SAY"]);
			end
		elseif (strsub(event, 1, 13) == "CHAT_MSG_YELL") then
			if (ChatAlert_SoundSettings["yell"] == 1) then
				ChatAlert_roar(8);	--PlaySoundFile("Interface\\AddOns\\ChatAlert\\Soundfiles\\ca_yell.wav");
			end
			if (ChatAlert_TextSettings["yell"] == 1) then
				ChatAlert_ChatMessage("[" .. sName .. ChatAlert_TEXT_YELL .. sMsg, ChatTypeInfo["YELL"]);
			end
		elseif (strsub(event, 1, 16) == "CHAT_MSG_CHANNEL") then
			if (ChatAlert_SoundSettings["channel"] == 1) then
				if (ChatAlert_SoundSettings["channel_"..strlower(arg9)] == 1) then
					PlaySoundFile("Interface\\AddOns\\ChatAlert\\Soundfiles\\ca_say.wav");
				end
			end
			if (ChatAlert_TextSettings["channel"] == 1) then
				if (ChatAlert_TextSettings["channel_"..strlower(arg9)] == 1) then
					ChatAlert_ChatMessage("[" .. arg9 .. "/" .. sName .. ChatAlert_TEXT_SAY .. sMsg, ChatTypeInfo["CHANNEL"]);
				end
			end
--		elseif (strsub(event, 1, 22) == "CHAT_MSG_MONSTER_EMOTE") then
--			if (ChatAlert_SoundSettings["monster_emote"] == 1) then
--				PlaySoundFile("Sound\\interface\\MagicClick.wav");
--			end
--			if (ChatAlert_TextSettings["monster_emote"] == 1) then
--				ChatAlert_ChatMessage("[NSC/" .. sName .. ChatAlert_TEXT_SAY .. sMsg, ChatTypeInfo["EMOTE"]);
--			end
		elseif (strsub(event, 1, 20) == "CHAT_MSG_MONSTER_SAY") then
			if (ChatAlert_SoundSettings["monster_say"] == 1) then
				PlaySoundFile("Sound\\interface\\MagicClick.wav");
			end
			if (ChatAlert_TextSettings["monster_say"] == 1) then
				ChatAlert_ChatMessage("[NSC/" .. sName .. ChatAlert_TEXT_SAY .. sMsg, ChatTypeInfo["SAY"]);
			end
		elseif (strsub(event, 1, 24) == "CHAT_MSG_MONSTER_WHISPER") then
			if (ChatAlert_SoundSettings["monster_whisper"] == 1) then
				PlaySoundFile("Sound\\interface\\MagicClick.wav");
			end
			if (ChatAlert_TextSettings["monster_whisper"] == 1) then
				ChatAlert_ChatMessage("[NSC/" .. sName .. ChatAlert_TEXT_SAY .. sMsg, ChatTypeInfo["WHISPER"]);
			end
		elseif (strsub(event, 1, 21) == "CHAT_MSG_MONSTER_YELL") then
			if (ChatAlert_SoundSettings["monster_yell"] == 1) then
				ChatAlert_roar(1);	--PlaySoundFile("Interface\\AddOns\\ChatAlert\\Soundfiles\\ca_monster_yell.wav");
			end
			if (ChatAlert_TextSettings["monster_yell"] == 1) then
				ChatAlert_ChatMessage("[NSC/" .. sName .. ChatAlert_TEXT_SAY .. sMsg, ChatTypeInfo["YELL"]);
			end
		end
	end
end

function ChatAlert_Extract_NextParameter(msg)
	local params = msg;
	local command = params;
	local index = strfind(command, " ");
	if ( index ) then
		command = strsub(command, 1, index-1);
		params = strsub(params, index+1);
	else
		params = "";
	end
	return command, params;
end

function ChatAlert_SlashCmd(msg)

	local cmd, parm = ChatAlert_Extract_NextParameter(msg);

	--ChatAlert_print("debug: cmd, parm = " .. cmd .. ", " .. parm);

	if (cmd and cmd == "on") then
		ChatAlert_on = 1;
		ChatAlert_print(ChatAlert_TEXT_ON);
	elseif (cmd and cmd == "off") then
		ChatAlert_on = 0;
		ChatAlert_print(ChatAlert_TEXT_OFF);
	elseif (cmd and cmd == "guild") then
		if  (parm and parm == "0") then
			ChatAlert_TextSettings["guild"] = 0;
			ChatAlert_print(ChatAlert_TEXT_GUILD_OFF);
		elseif  (parm and parm == "1") then
			ChatAlert_TextSettings["guild"] = 1;
			ChatAlert_print(ChatAlert_TEXT_GUILD_OFF);
		elseif (ChatAlert_TextSettings["guild"] == 1)  then
			ChatAlert_TextSettings["guild"] = 0;
			ChatAlert_print(ChatAlert_TEXT_GUILD_OFF);
		else
			ChatAlert_TextSettings["guild"] = 1;
			ChatAlert_print(ChatAlert_TEXT_GUILD_ON);
		end
	elseif (cmd and cmd == "party") then
		if  (parm and parm == "0") then
			ChatAlert_TextSettings["party"] = 0;
			ChatAlert_print(ChatAlert_TEXT_PARTY_OFF);
		elseif  (parm and parm == "1") then
			ChatAlert_TextSettings["party"] = 1;
			ChatAlert_print(ChatAlert_TEXT_PARTY_ON);
		elseif (ChatAlert_TextSettings["party"] == 1)  then
			ChatAlert_TextSettings["party"] = 0;
			ChatAlert_print(ChatAlert_TEXT_PARTY_OFF);
		else
			ChatAlert_TextSettings["party"] = 1;
			ChatAlert_print(ChatAlert_TEXT_PARTY_ON);
		end
	elseif (cmd and cmd == "raid") then
		if  (parm and parm == "0") then
			ChatAlert_TextSettings["raid"] = 0;
			ChatAlert_print(ChatAlert_TEXT_RAID_OFF);
		elseif  (parm and parm == "1") then
			ChatAlert_TextSettings["raid"] = 1;
			ChatAlert_print(ChatAlert_TEXT_RAID_ON);
		elseif (ChatAlert_TextSettings["raid"] == 1)  then
			ChatAlert_TextSettings["raid"] = 0;
			ChatAlert_print(ChatAlert_TEXT_RAID_OFF);
		else
			ChatAlert_TextSettings["raid"] = 1;
			ChatAlert_print(ChatAlert_TEXT_RAID_ON);
		end
	elseif (cmd and cmd == "whisper") then
		if  (parm and parm == "0") then
			ChatAlert_TextSettings["whisper"] = 0;
			ChatAlert_print(ChatAlert_TEXT_WHISPER_OFF);
		elseif  (parm and parm == "1") then
			ChatAlert_TextSettings["whisper"] = 1;
			ChatAlert_print(ChatAlert_TEXT_WHISPER_ON);
		elseif (ChatAlert_TextSettings["whisper"] == 1)  then
			ChatAlert_TextSettings["whisper"] = 0;
			ChatAlert_print(ChatAlert_TEXT_WHISPER_OFF);
		else
			ChatAlert_TextSettings["whisper"] = 1;
			ChatAlert_print(ChatAlert_TEXT_WHISPER_ON);
		end
	elseif (cmd and cmd == "channel") then
		if  (parm and parm == "0") then
			ChatAlert_TextSettings["channel"] = 0;
			ChatAlert_print(ChatAlert_TEXT_CHANNEL_OFF);
		elseif  (parm and parm == "1") then
			ChatAlert_TextSettings["channel"] = 1;
			ChatAlert_print(ChatAlert_TEXT_CHANNEL_ON);
		elseif (ChatAlert_TextSettings["channel"] == 1)  then
			ChatAlert_TextSettings["channel"] = 0;
			ChatAlert_print(ChatAlert_TEXT_CHANNEL_OFF);
		else
			ChatAlert_TextSettings["channel"] = 1;
			ChatAlert_print(ChatAlert_TEXT_CHANNEL_ON);
		end
	elseif (cmd and cmd == "say") then
		if  (parm and parm == "0") then
			ChatAlert_TextSettings["say"] = 0;
			ChatAlert_print(ChatAlert_TEXT_SAY_OFF);
		elseif  (parm and parm == "1") then
			ChatAlert_TextSettings["say"] = 1;
			ChatAlert_print(ChatAlert_TEXT_SAY_ON);
		elseif (ChatAlert_TextSettings["say"] == 1)  then
			ChatAlert_TextSettings["say"] = 0;
			ChatAlert_print(ChatAlert_TEXT_SAY_OFF);
		else
			ChatAlert_TextSettings["say"] = 1;
			ChatAlert_print(ChatAlert_TEXT_SAY_ON);
		end
	elseif (cmd and cmd == "center") then
		ChatAlert_config:SetPoint("CENTER", "UIParent", "CENTER", 0, 0);
		ChatAlert_config:Show();
		AlertFrame:SetBackdropBorderColor(1, 1, 1, 1);
	elseif (cmd and cmd == "test") then
		PlaySoundFile("Interface\\AddOns\\ChatAlert\\Soundfiles\\ca_guild.wav");
		ChatAlert_print("ChatAlert - Test = 1");
		ChatAlert_testmode = 1;
	elseif (cmd and cmd == "info") then
		ChatAlert_info();
	else
		ChatAlert_toggle_visible();
	end
end

function ChatAlert_info()
	ChatAlert_print(ChatAlert_TEXT_HOWTO);
	ChatAlert_print(ChatAlert_TEXT_OPT_ONOFF .. ChatAlert_on);
--	if (ChatAlert_on == 1) then
--		ChatAlert_print(ChatAlert_TEXT_OPT_GUILD .. ChatAlert_TextSettings["guild"]);
--		ChatAlert_print(ChatAlert_TEXT_OPT_PARTY .. ChatAlert_TextSettings["party"]);
--		ChatAlert_print(ChatAlert_TEXT_OPT_RAID .. ChatAlert_TextSettings["raid"]);
--		ChatAlert_print(ChatAlert_TEXT_OPT_WHISPER .. ChatAlert_TextSettings["whisper"]);
--	end
end

function ChatAlert_ChatMessage(msg, color)
	AlertFrame:AddMessage(msg, color.r, color.g, color.b);
end

function ChatAlert_OwnMessage(msg)
	AlertFrame:AddMessage(msg, ChatAlert_color["r"], ChatAlert_color["g"], ChatAlert_color["b"]);
end

function ChatAlert_print(msg)
	if (DEFAULT_CHAT_FRAME) then
		DEFAULT_CHAT_FRAME:AddMessage(msg, ChatAlert_color["r"], ChatAlert_color["g"], ChatAlert_color["b"]);
	end
end

function ChatAlert_debug(msg)
	if (ChatAlert_testmode == 1) then
		ChatAlert_print("DEBUG: "..msg);
		ChatAlert_OwnMessage("DEBUG: "..msg);
	end
end

function ChatAlert_toggle_visible()
	if (ChatAlert_config:IsVisible()) then
		ChatAlert_debug("Hide ChatAlert Menu");
		ChatAlert_config:Hide();
		AlertFrame:SetBackdropBorderColor(1, 1, 1, 0);
	else
		ChatAlert_debug("debug: Show ChatAlert Menu");
		ChatAlert_config:Show();
		AlertFrame:SetBackdropBorderColor(1, 1, 1, 1);
	end
end

function ChatAlert_ToggleText(setting, checked)
	if (checked) then
		ChatAlert_TextSettings[setting] = 1;
	else
		ChatAlert_TextSettings[setting] = 0;
	end
	ChatAlert_debug("ChatAlert_ToggleText("..setting..", "..ChatAlert_TextSettings[setting]..")");
end

function ChatAlert_ToggleSound(setting, checked)
	if (checked) then
		ChatAlert_SoundSettings[setting] = 1;
	else
		ChatAlert_SoundSettings[setting] = 0;
	end
	ChatAlert_debug("ChatAlert_ToggleSound("..setting..", "..ChatAlert_SoundSettings[setting]..")");
end

function ChatAlert_XSlider_OnValueChanged()
	ChatAlert_config_XSliderText:SetText(ChatAlert_TEXT_XSLIDERNAME..": "..this:GetValue());
	ChatAlert_TextSettings["TextXPos"] = this:GetValue();
	AlertFrame:SetPoint("CENTER", "UIParent", "CENTER", ChatAlert_TextSettings["TextXPos"], ChatAlert_TextSettings["TextYPos"]);
end

function ChatAlert_YSlider_OnValueChanged()
	ChatAlert_config_YSliderText:SetText(ChatAlert_TEXT_YSLIDERNAME..": "..this:GetValue());
	ChatAlert_TextSettings["TextYPos"] = this:GetValue();
	AlertFrame:SetPoint("CENTER", "UIParent", "CENTER", ChatAlert_TextSettings["TextXPos"], ChatAlert_TextSettings["TextYPos"]);
end

function ChatAlert_TimeSlider_OnValueChanged()
	ChatAlert_config_TimeSliderText:SetText(ChatAlert_TEXT_TIMESLIDERNAME..": "..this:GetValue().." s");
	ChatAlert_TextSettings["fadeTime"] = this:GetValue();
	AlertFrame:SetTimeVisible(ChatAlert_TextSettings["fadeTime"]);
end

function ChatAlert_HeightSlider_OnValueChanged()
	ChatAlert_config_HeightSliderText:SetText(ChatAlert_TEXT_HEIGHTSLIDERNAME..": "..this:GetValue().." px");
	ChatAlert_TextSettings["textHeight"] = this:GetValue();
	ChatAlert_SetFontHeight(ChatAlert_TextSettings["textHeight"]);
end

function ChatAlert_SetFontHeight(height)
	if (height < 16) then
		AlertFrame:SetFont("Fonts\\FRIZQT__.TTF", height);
	elseif (height < 30) then
		AlertFrame:SetFont("Fonts\\FRIZQT__.TTF", height, "OUTLINE");
	else
		AlertFrame:SetFont("Fonts\\FRIZQT__.TTF", height, "THICKOUTLINE");
	end
end

function ChatAlert_SelectAlertColor()
	local frame = this:GetParent();
	frame.r = ChatAlert_color["r"];
	frame.g = ChatAlert_color["g"];
	frame.b = ChatAlert_color["b"];
	frame.swatchFunc = ChatAlert_SetAlertColor;
	frame.cancelFunc = ChatAlert_CancelAlertColor;
	CloseMenus();
	UIDropDownMenuButton_OpenColorPicker(frame);
end

function ChatAlert_SetAlertColor()
	local r, g, b = ColorPickerFrame:GetColorRGB();
	ChatAlert_color["r"] = r;
	ChatAlert_color["g"] = g;
	ChatAlert_color["b"] = b;
	ChatAlert_config_AlertColorSwatch_NormalTexture:SetVertexColor(r, g, b);
end

function ChatAlert_CancelAlertColor(val)
	ChatAlert_color["r"] = val.r;
	ChatAlert_color["g"] = val.g;
	ChatAlert_color["b"] = val.b;
	ChatAlert_config_AlertColorSwatch_NormalTexture:SetVertexColor(val.r, val.g, val.b);
end

function ChatAlert_roar(id)
	local _,race = UnitRace("player");
	local soundTable = 
		{	"Sound\\Character\\PlayerRoars\\CharacterRoarsDwarfFemale.wav"
		,	"Sound\\Character\\PlayerRoars\\CharacterRoarsDwarfMale.wav"
		,	"Sound\\Character\\PlayerRoars\\CharacterRoarsGnomeFemale.wav"
		,	"Sound\\Character\\PlayerRoars\\CharacterRoarsGnomeMale.wav"
		,	"Sound\\Character\\PlayerRoars\\CharacterRoarsHumanFemale.wav"
		,	"Sound\\Character\\PlayerRoars\\CharacterRoarsHumanMale.wav"
		,	"Sound\\Character\\PlayerRoars\\CharacterRoarsNightElfFemale.wav"
		,	"Sound\\Character\\PlayerRoars\\CharacterRoarsNightElfMale.wav"
		,	"Sound\\Character\\PlayerRoars\\CharacterRoarsOrcFemale.wav"
		,	"Sound\\Character\\PlayerRoars\\CharacterRoarsOrcMale.wav"
		,	"Sound\\Character\\PlayerRoars\\CharacterRoarsTaurenFemale.wav"
		,	"Sound\\Character\\PlayerRoars\\CharacterRoarsTaurenMale.wav"
		,	"Sound\\Character\\PlayerRoars\\CharacterRoarsTrollFemale.wav"
		,	"Sound\\Character\\PlayerRoars\\CharacterRoarsTrollMale.wav"
		,	"Sound\\Character\\PlayerRoars\\CharacterRoarsUndeadFemale.wav"
		,	"Sound\\Character\\PlayerRoars\\CharacterRoarsUndeadMale.wav"
		}
	;
	PlaySoundFile(soundTable[id]);
end


function ChatAlert_AddNamedChannel(cTitle)

	channelID = 0;

	ChatAlert_debug("ChatAlert_AddNamedChannel("..cTitle..")");

	-- Find named channel in ChatAlert_List if it has been logged already
	if (ChatAlert_List) then
		ChatAlert_debug("- Searching ChatAlert_List for '"..cTitle.."'");
		for index, value in ChatAlert_List do
			ChatAlert_debug("- - value = "..value);

			-- compare titles but don't break out until all channel descriptions have been checked
			if ( value ) then
				if ( strlower(cTitle) == strlower(value) ) then
					ChatAlert_debug("- HEUREKA!!!");
					channelID = index;
				end
			end
		end
	else
		ChatAlert_debug("- Initialize ChatAlert_List!");
		ChatAlert_List = {};
	end
	if (channelID == 0) then
		channelID = getn(ChatAlert_List) + 1;
		ChatAlert_debug("- Add new channel '"..cTitle.."' with id="..channelID.."!");
		table.insert(ChatAlert_List, {});
		ChatAlert_List[channelID] = cTitle;
		ChatAlert_TextSettings["channel_"..strlower(cTitle)]  = ChatAlert_TextSettings["channel"];
		ChatAlert_SoundSettings["channel_"..strlower(cTitle)] = ChatAlert_SoundSettings["channel"];
		if (ChatAlert_config:IsVisible()) then
			ChatAlert_Refresh();
		end
	else
		ChatAlert_debug("Channel found at id="..channelID.."!");
	end

end

-- Returns true if data in value table match the current criteria, false otherwise
local function ChatAlert_MatchesSearch(index, value)
	-- If there is no search text defined, return true
	if ( not searchText ) then
		return true;
	else
		-- Otherwise, cycle through named channels looking for search text
		for i, v in value do
			if ( string.find(strupper(tostring(value[i])), strupper(searchText)) ) then
				return true;
			end
		end
	end
	-- Return false if search text is defined and not found in the named channels
	return false;
end

-- Builds the SortedTable array and populates it with the indices of ChatAlert_List that match
-- the current criteria. This array can then be sorted without changing the original list.
local function ChatAlert_BuildSortedTable()
	ChatAlert_debug("ChatAlert_BuildSortedTable()");

	local iNew = 1;
	-- Initialize blank table
	SortedTable = { };
	-- Populate table with named channel IDs that match current criteria
	for index, value in ChatAlert_List do
		if ( ChatAlert_MatchesSearch(index, value) ) then
			SortedTable[iNew] = index;
			iNew = iNew + 1;
		end
	end
	-- Store size of sorted table
	sizeSortedTable = iNew - 1;
	-- Sort table
	table.sort(SortedTable, ChatAlert_SortComparison);
end

function ChatAlert_SortComparison(a, b)
	return (a < b)
end

local function ChatAlert_Refresh()
	ChatAlert_debug("ChatAlert_Refresh()");

	ChatAlert_BuildSortedTable();
	ChatAlert_Update();
end

function ChatAlert_Update()
	ChatAlert_debug("ChatAlert_Update()");

	-- Get number of named channels
	local listSize = getn(ChatAlert_List);

	-- Build sorted table if it hasn't been created yet
	if ( not SortedTable ) then
		ChatAlert_BuildSortedTable();
	end

	-- Update the scroll frame and add the named channel data
	FauxScrollFrame_Update(ChatAlertListScrollFrame, sizeSortedTable, ChatAlert_ITEMS_SHOWN, ChatAlert_ITEM_HEIGHT);
	for iChannel = 1, ChatAlert_ITEMS_SHOWN, 1 do
		local channelIndex = iChannel + FauxScrollFrame_GetOffset(ChatAlertListScrollFrame);
		--ChatAlert_debug("channelIndex = "..channelIndex);
		local listFrame = "ChatAlertListFrame"..iChannel;
		--ChatAlert_debug("listFrame    = "..listFrame);
		if ( channelIndex <= sizeSortedTable ) then
			local color;
			-- Get channel information
			local index = SortedTable[channelIndex];
			local title = ChatAlert_List[index];
			-- Check to make sure none of the data is nil
			if ( not title ) then
				title = "";
			end
			-- Add named channel data to frame
			getglobal(listFrame.."_NChannel"):SetText(title);
			getglobal(listFrame.."_TChannel"):SetChecked(ChatAlert_TextSettings["channel_"..strlower(title)]);
			getglobal(listFrame.."_SChannel"):SetChecked(ChatAlert_SoundSettings["channel_"..strlower(title)]);
			getglobal(listFrame):Show();
		else
			-- Hide the list frame if there is no data for it
			getglobal(listFrame):Hide();
		end
	end
end

function ChatAlert_OnShow()
	PlaySound("igMainMenuOpen");
	ChatAlert_Refresh();
end

function ChatAlert_OnHide()
	PlaySound("igMainMenuClose");
--[[
	HideUIPanel(ChatAlertDetailFrame);
	HideUIPanel(ChatAlertEditFrame);
	HideUIPanel(ChatAlertOptionsFrame);
	HideUIPanel(ChatAlertConfirmFrame);
	ChatAlertFrameSearchEditBox:Hide();
	ChatAlertFrameClearButton:Hide();
	ChatAlertFrameSubmitButton:Hide();
	ChatAlertFrameSearchButton:Show();
]]
end

